<?php

$schema_data = $schema_updates = array();

// We need some default increments first, so add them first

// phpbb_styles_imageset
$schema_data[] = array(
	'table'		=> 'phpbb_styles_imageset',
	'columns'	=> array('imageset_name', 'imageset_copyright', 'imageset_path'),
	'data'		=> array(
		array('prosilver', '&copy; phpBB Group', 'prosilver'),
	),
	'store_auto_increment'	=> 'IMAGESET_ID',
);

// phpbb_styles_template
$schema_data[] = array(
	'table'		=> 'phpbb_styles_template',
	'columns'	=> array('template_name', 'template_copyright', 'template_path', 'bbcode_bitfield'),
	'data'		=> array(
		array('prosilver', '&copy; phpBB Group', 'prosilver', 'lNg='),
	),
	'store_auto_increment'	=> 'TEMPLATE_ID',
);

// phpbb_styles_theme
$schema_data[] = array(
	'table'		=> 'phpbb_styles_theme',
	'columns'	=> array('theme_name', 'theme_copyright', 'theme_path', 'theme_storedb', 'theme_data'),
	'data'		=> array(
		array('prosilver', '&copy; phpBB Group', 'prosilver', 1, ''),
	),
	'store_auto_increment'	=> 'THEME_ID',
);

// phpbb_styles
$schema_data[] = array(
	'table'		=> 'phpbb_styles',
	'columns'	=> array('style_name', 'style_copyright', 'style_active', 'template_id', 'theme_id', 'imageset_id'),
	'data'		=> array(
		array('prosilver', '&copy; phpBB Group', 1, array('auto_increment' => 'TEMPLATE_ID:0'), array('auto_increment' => 'THEME_ID:0'), array('auto_increment' => 'IMAGESET_ID:0')),
	),
	'store_auto_increment'	=> 'STYLE_ID',
);

// phpbb_config
$schema_data[] = array(
	'table'		=> 'phpbb_config',
	'columns'	=> array('string:config_name', 'string:config_value'),
	'data'		=> array(
		array('active_sessions', '0'),
		array('allow_attachments', '1'),
		array('allow_autologin', '1'),
		array('allow_avatar_local', '0'),
		array('allow_avatar_remote', '0'),
		array('allow_avatar_upload', '0'),
		array('allow_bbcode', '1'),
		array('allow_birthdays', '1'),
		array('allow_bookmarks', '1'),
		array('allow_emailreuse', '0'),
		array('allow_forum_notify', '1'),
		array('allow_mass_pm', '1'),
		array('allow_name_chars', 'USERNAME_CHARS_ANY'),
		array('allow_namechange', '0'),
		array('allow_nocensors', '0'),
		array('allow_pm_attach', '0'),
		array('allow_post_flash', '1'),
		array('allow_post_links', '1'),
		array('allow_privmsg', '1'),
		array('allow_sig', '1'),
		array('allow_sig_bbcode', '1'),
		array('allow_sig_flash', '0'),
		array('allow_sig_img', '1'),
		array('allow_sig_links', '1'),
		array('allow_sig_pm', '1'),
		array('allow_sig_smilies', '1'),
		array('allow_smilies', '1'),
		array('allow_topic_notify', '1'),
		array('attachment_quota', '52428800'),
		array('auth_bbcode_pm', '1'),
		array('auth_flash_pm', '0'),
		array('auth_img_pm', '1'),
		array('auth_method', 'db'),
		array('auth_smilies_pm', '1'),
		array('avatar_filesize', '6144'),
		array('avatar_gallery_path', 'images/avatars/gallery'),
		array('avatar_max_height', '90'),
		array('avatar_max_width', '90'),
		array('avatar_min_height', '20'),
		array('avatar_min_width', '20'),
		array('avatar_path', 'images/avatars/upload'),
		array('avatar_salt', '{AVATAR_SALT}'),
		array('board_contact', '{BOARD_CONTACT}'),
		array('board_disable', '0'),
		array('board_disable_msg', ''),
		array('board_dst', '0'),
		array('board_email', '{BOARD_EMAIL}'),
		array('board_email_from', '0'),
		array('board_email_sig', '{L_CONFIG_BOARD_EMAIL_SIG}'),
		array('board_hide_emails', '1'),
		array('board_startdate', '{BOARD_STARTDATE}'),
		array('board_timezone', '0'),
		array('browser_check', '1'),
		array('bump_interval', '10'),
		array('bump_type', 'd'),
		array('cache_gc', '7200'),
		array('captcha_plugin', '{CAPTCHA_PLUGIN}'),
		array('captcha_gd_foreground_noise', '0'),
		array('captcha_gd_x_grid', '25'),
		array('captcha_gd_y_grid', '25'),
		array('captcha_gd_wave', '0'),
		array('captcha_gd_3d_noise', '1'),
		array('captcha_gd_fonts', '1'),
		array('confirm_refresh', '1'),
		array('check_attachment_content', '1'),
		array('check_dnsbl', '0'),
		array('chg_passforce', '0'),
		array('cookie_domain', '{COOKIE_DOMAIN}'),
		array('cookie_name', '{COOKIE_NAME}'),
		array('cookie_path', '/'),
		array('cookie_secure', '{COOKIE_SECURE}'),
		array('coppa_enable', '0'),
		array('coppa_fax', ''),
		array('coppa_mail', ''),
		array('database_gc', '604800'),
		array('dbms_version', '{DBMS_VERSION}'),
		array('default_dateformat', '{DEFAULT_DATEFORMAT}'),
		array('default_lang', '{DEFAULT_LANG}'),
		array('default_style', array('auto_increment' => 'STYLE_ID:0')),
		array('display_last_edited', '1'),
		array('display_order', '0'),
		array('edit_time', '0'),
		array('email_check_mx', '0'),
		array('email_enable', '{EMAIL_ENABLE}'),
		array('email_function_name', 'mail'),
		array('email_package_size', '50'),
		array('enable_confirm', '1'),
		array('enable_pm_icons', '1'),
		array('enable_post_confirm', '1'),
		array('enable_queue_trigger', '0'),
		array('flood_interval', '15'),
		array('force_server_vars', '{FORCE_SERVER_VARS}'),
		array('form_token_lifetime', '7200'),
		array('form_token_mintime', '0'),
		array('form_token_sid_guests', '1'),
		array('forward_pm', '1'),
		array('forwarded_for_check', '0'),
		array('full_folder_action', '2'),
		array('fulltext_mysql_max_word_len', '254'),
		array('fulltext_mysql_min_word_len', '4'),
		array('fulltext_native_common_thres', '5'),
		array('fulltext_native_load_upd', '1'),
		array('fulltext_native_max_chars', '14'),
		array('fulltext_native_min_chars', '3'),
		array('gzip_compress', '0'),
		array('hot_threshold', '25'),
		array('icons_path', 'images/icons'),
		array('img_create_thumbnail', '0'),
		array('img_display_inlined', '1'),
		array('img_imagick', '{IMG_IMAGICK}'),
		array('img_link_height', '0'),
		array('img_link_width', '0'),
		array('img_max_height', '0'),
		array('img_max_thumb_width', '400'),
		array('img_max_width', '0'),
		array('img_min_thumb_filesize', '12000'),
		array('ip_check', '3'),
		array('jab_enable', '0'),
		array('jab_host', ''),
		array('jab_password', ''),
		array('jab_package_size', '20'),
		array('jab_port', '5222'),
		array('jab_use_ssl', '0'),
		array('jab_username', ''),
		array('ldap_base_dn', ''),
		array('ldap_email', ''),
		array('ldap_password', ''),
		array('ldap_port', ''),
		array('ldap_server', ''),
		array('ldap_uid', ''),
		array('ldap_user', ''),
		array('ldap_user_filter', ''),
		array('limit_load', '0'),
		array('limit_search_load', '0'),
		array('load_anon_lastread', '0'),
		array('load_birthdays', '1'),
		array('load_cpf_memberlist', '0'),
		array('load_cpf_viewprofile', '1'),
		array('load_cpf_viewtopic', '0'),
		array('load_db_lastread', '1'),
		array('load_db_track', '1'),
		array('load_jumpbox', '1'),
		array('load_moderators', '1'),
		array('load_online', '1'),
		array('load_online_guests', '1'),
		array('load_online_time', '5'),
		array('load_online_track', '1'),
		array('load_search', '1'),
		array('load_tplcompile', '0'),
		array('load_user_activity', '1'),
		array('max_attachments', '3'),
		array('max_attachments_pm', '1'),
		array('max_autologin_time', '0'),
		array('max_filesize', '262144'),
		array('max_filesize_pm', '262144'),
		array('max_login_attempts', '3'),
		array('max_name_chars', '20'),
		array('max_num_search_keywords', '10'),
		array('max_pass_chars', '30'),
		array('max_poll_options', '10'),
		array('max_poll_chars', '60000'),
		array('max_post_font_size', '200'),
		array('max_post_img_height', '0'),
		array('max_post_img_width', '0'),
		array('max_post_smilies', '0'),
		array('max_post_urls', '0'),
		array('max_quote_depth', '3'),
		array('max_reg_attempts', '5'),
		array('max_sig_chars', '255'),
		array('max_sig_font_size', '200'),
		array('max_sig_img_height', '0'),
		array('max_sig_img_width', '0'),
		array('max_sig_smilies', '0'),
		array('max_sig_urls', '5'),
		array('min_name_chars', '3'),
		array('min_pass_chars', '6'),
		array('min_search_author_chars', '3'),
		array('mime_triggers', 'body|head|html|img|plaintext|a href|pre|script|table|title'),
		array('override_user_style', '0'),
		array('pass_complex', 'PASS_TYPE_ANY'),
		array('pm_edit_time', '0'),
		array('pm_max_boxes', '4'),
		array('pm_max_msgs', '50'),
		array('pm_max_recipients', '0'),
		array('posts_per_page', '10'),
		array('print_pm', '1'),
		array('queue_interval', '600'),
		array('queue_trigger_posts', '3'),
		array('ranks_path', 'images/ranks'),
		array('require_activation', '0'),
		array('referer_validation', '{REFERER_VALIDATION}'),
		array('script_path', '{SCRIPT_PATH}'),
		array('search_block_size', '250'),
		array('search_gc', '7200'),
		array('search_indexing_state', ''),
		array('search_interval', '0'),
		array('search_anonymous_interval', '0'),
		array('search_type', 'fulltext_native'),
		array('search_store_results', '1800'),
		array('secure_allow_deny', '1'),
		array('secure_allow_empty_referer', '1'),
		array('secure_downloads', '0'),
		array('server_name', '{SERVER_NAME}'),
		array('server_port', '{SERVER_PORT}'),
		array('server_protocol', '{SERVER_PROTOCOL}'),
		array('session_gc', '3600'),
		array('session_length', '3600'),
		array('site_desc', '{L_CONFIG_SITE_DESC}'),
		array('sitename', '{L_CONFIG_SITENAME}'),
		array('smilies_path', 'images/smilies'),
		array('smtp_auth_method', '{SMTP_AUTH_METHOD}'),
		array('smtp_delivery', '{SMTP_DELIVERY}'),
		array('smtp_host', '{SMTP_HOST}'),
		array('smtp_password', '{SMTP_PASSWORD}'),
		array('smtp_port', '25'),
		array('smtp_username', '{SMTP_USERNAME}'),
		array('topics_per_page', '25'),
		array('tpl_allow_php', '0'),
		array('upload_icons_path', 'images/upload_icons'),
		array('upload_path', 'files'),
		array('version', '3.1.0-dev1'),
		array('warnings_expire_days', '90'),
		array('warnings_gc', '14400'),
	),
);

// Ranks
$schema_data[] = array(
	'table'		=> 'phpbb_ranks',
	'columns'	=> array('rank_title', 'rank_min', 'rank_special', 'rank_image'),
	'data'		=> array(
		array('{L_RANKS_SITE_ADMIN_TITLE}', 0, 1, ''),
	),
	'store_auto_increment'	=> 'RANK_ID',
);

// Groups
$schema_data[] = array(
	'table'		=> 'phpbb_groups',
	'columns'	=> array('group_name', 'group_name_clean', 'group_type', 'group_founder_manage', 'group_colour', 'group_legend', 'group_avatar', 'group_desc', 'group_desc_uid', 'group_max_recipients'),
	'data'		=> array(
		array('GUESTS', 'guests', 3, 0, '', 0, '', '', '', 0),
		array('REGISTERED', 'registered', 3, 0, '', 0, '', '', '', 5),
		array('REGISTERED_COPPA', 'registered_coppa', 3, 0, '', 0, '', '', '', 5),
		array('GLOBAL_MODERATORS', 'global_moderators', 3, 0, '00AA00', 1, '', '', '', 50),
		array('ADMINISTRATORS', 'administrators', 3, 1, 'AA0000', 1, '', '', '', 50),
		array('BOTS', 'bots', 3, 0, '9E8DA7', 0, '', '', '', 5),
	),
	'store_auto_increment'	=> 'GROUP_ID',
);

// Users
$schema_data[] = array(
	'table'		=> 'phpbb_users',
	'columns'	=> array('user_type', 'group_id', 'username', 'username_clean', 'user_regdate', 'user_password', 'user_email', 'user_lang', 'user_style', 'user_rank', 'user_colour', 'user_posts', 'user_permissions', 'user_ip', 'user_birthday', 'user_lastpage', 'user_last_confirm_key', 'user_post_sortby_type', 'user_post_sortby_dir', 'user_topic_sortby_type', 'user_topic_sortby_dir', 'user_avatar', 'user_sig', 'user_sig_bbcode_uid', 'user_from', 'user_icq', 'user_aim', 'user_yim', 'user_msnm', 'user_jabber', 'user_website', 'user_occ', 'user_interests', 'user_actkey', 'user_newpasswd', 'user_allow_massemail', 'user_email_hash', 'user_dateformat'),
	'data'		=> array(
		// Anonymous
		array(2, array('auto_increment' => 'GROUP_ID:0'), 'Anonymous', 'anonymous', '{CURRENT_TIME}', '', '', '{DEFAULT_LANG}', array('auto_increment' => 'STYLE_ID:0'), 0, '', 0, '', '{USER_IP}', '', '', '', 't', 'a', 't', 'd', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 0, 0, '{DEFAULT_DATEFORMAT}'),
		// Admin
		array(3, array('auto_increment' => 'GROUP_ID:4'), '{ADMIN_NAME}', '{ADMIN_NAME_CLEAN}', '{CURRENT_TIME}', '{ADMIN_PASSWORD}', '{ADMIN_EMAIL}', '{DEFAULT_LANG}', array('auto_increment' => 'STYLE_ID:0'), array('auto_increment' => 'RANK_ID:0'), 'AA0000', 1, '', '{USER_IP}', '', '', '', 't', 'a', 't', 'd', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 1, '{ADMIN_EMAIL_HASH}', '{DEFAULT_DATEFORMAT}'),
	),
	'store_auto_increment'	=> 'USER_ID',
);

// Dynamic config values
$schema_data[] = array(
	'table'		=> 'phpbb_config',
	'columns'	=> array('string:config_name', 'string:config_value', 'is_dynamic'),
	'data'		=> array(
		array('cache_last_gc', '0', 1),
		array('cron_lock', '0', 1),
		array('database_last_gc', '0', 1),
		array('last_queue_run', '0', 1),
		array('newest_user_colour', 'AA0000', 1),
		array('newest_user_id', array('auto_increment' => 'USER_ID:1'), 1),
		array('newest_username', '{NEWEST_USERNAME}', 1),
		array('num_files', '0', 1),
		array('num_posts', '1', 1),
		array('num_topics', '1', 1),
		array('num_users', '1', 1),
		array('rand_seed', '0', 1),
		array('rand_seed_last_update', '0', 1),
		array('record_online_date', '0', 1),
		array('record_online_users', '0', 1),
		array('search_last_gc', '0', 1),
		array('session_last_gc', '0', 1),
		array('upload_dir_size', '0', 1),
		array('warnings_last_gc', '0', 1),
	),
);

// Forums
$schema_data[] = array(
	'table'		=> 'phpbb_forums',
	'columns'	=> array('forum_name', 'forum_desc', 'left_id', 'right_id', 'parent_id', 'forum_type', 'forum_posts', 'forum_topics', 'forum_topics_real', 'forum_last_post_id', 'forum_last_poster_id', 'forum_last_poster_name', 'forum_last_poster_colour', 'forum_last_post_subject', 'forum_last_post_time', 'forum_link', 'forum_password', 'forum_image', 'forum_rules', 'forum_rules_link', 'forum_rules_uid', 'forum_desc_uid', 'prune_days', 'prune_viewed', 'forum_parents'),
	'data'		=> array(
		array('{L_FORUMS_FIRST_CATEGORY}', '', 1, 4, 0, 0, 1, 1, 1, 0, array('auto_increment' => 'USER_ID:1'), '{ADMIN_NAME}', 'AA0000', '{L_TOPICS_TOPIC_TITLE}', '{CURRENT_TIME}', '', '', '', '', '', '', '', 0, 0, ''),
		array('{L_FORUMS_TEST_FORUM_TITLE}', '{L_FORUMS_TEST_FORUM_DESC}', 2, 3, array('auto_increment' => 'FORUM_ID:0'), 1, 1, 1, 1, 0, array('auto_increment' => 'USER_ID:1'), '{ADMIN_NAME}', 'AA0000', '{L_TOPICS_TOPIC_TITLE}', '{CURRENT_TIME}', '', '', '', '', '', '', '', 0, 0, ''),
	),
	'store_auto_increment' => 'FORUM_ID',
);

// Demo Topic
$schema_data[] = array(
	'table'		=> 'phpbb_topics',
	'columns'	=> array('topic_title', 'topic_poster', 'topic_time', 'topic_views', 'topic_replies', 'topic_replies_real', 'forum_id', 'topic_status', 'topic_type', 'topic_first_post_id', 'topic_first_poster_name', 'topic_first_poster_colour', 'topic_last_post_id', 'topic_last_poster_id', 'topic_last_poster_name', 'topic_last_poster_colour', 'topic_last_post_subject', 'topic_last_post_time', 'topic_last_view_time', 'poll_title'),
	'data'		=> array(
		array('{L_TOPICS_TOPIC_TITLE}', array('auto_increment' => 'USER_ID:1'), '{CURRENT_TIME}', 0, 0, 0, array('auto_increment' => 'FORUM_ID:1'), 0, 0, 0, '{ADMIN_NAME}', 'AA0000', 0, array('auto_increment' => 'USER_ID:1'), '{ADMIN_NAME}', 'AA0000', '{L_TOPICS_TOPIC_TITLE}', '{CURRENT_TIME}', 0, ''),
	),
	'store_auto_increment' => 'TOPIC_ID',
);

// Demo Post
$schema_data[] = array(
	'table'		=> 'phpbb_posts',
	'columns'	=> array('topic_id', 'forum_id', 'poster_id', 'icon_id', 'post_time', 'post_username', 'poster_ip', 'post_subject', 'post_text', 'post_checksum', 'bbcode_uid'),
	'data'		=> array(
		array(array('auto_increment' => 'TOPIC_ID:0'), array('auto_increment' => 'FORUM_ID:1'), array('auto_increment' => 'USER_ID:1'), 0, '{CURRENT_TIME}', '', '{USER_IP}', '{L_TOPICS_TOPIC_TITLE}', '{L_DEFAULT_INSTALL_POST}', '', ''),
	),
	'store_auto_increment' => 'POST_ID',
);

// Admin posted to the demo topic
$schema_data[] = array(
	'table'		=> 'phpbb_topics_posted',
	'columns'	=> array('user_id', 'topic_id', 'topic_posted'),
	'data'		=> array(
		array(array('auto_increment' => 'USER_ID:1'), array('auto_increment' => 'TOPIC_ID:0'), 1),
	),
);

// Update forums table
$schema_updates[] = array(
	'table'		=> 'phpbb_forums',
	'columns'	=> array('forum_last_post_id'),
	'data'		=> array(array('auto_increment' => 'POST_ID:0')),
);

// Update topics table
$schema_updates[] = array(
	'table'		=> 'phpbb_topics',
	'columns'	=> array('topic_first_post_id', 'topic_last_post_id'),
	'data'		=> array(array('auto_increment' => 'POST_ID:0'), array('auto_increment' => 'POST_ID:0')),
	'where'		=> array(
		array('topic_id' => array('auto_increment' => 'TOPIC_ID:0')),
	),
);

// User -> Group
$schema_data[] = array(
	'table'		=> 'phpbb_user_group',
	'columns'	=> array('group_id', 'user_id', 'user_pending', 'group_leader'),
	'data'		=> array(
		array(array('auto_increment' => 'GROUP_ID:0'), array('auto_increment' => 'USER_ID:0'), 0, 0),
		array(array('auto_increment' => 'GROUP_ID:1'), array('auto_increment' => 'USER_ID:1'), 0, 0),
		array(array('auto_increment' => 'GROUP_ID:3'), array('auto_increment' => 'USER_ID:1'), 0, 0),
		array(array('auto_increment' => 'GROUP_ID:4'), array('auto_increment' => 'USER_ID:1'), 0, 1),
	),
);

// Forum related auth options
$schema_data[] = array(
	'table'		=> 'phpbb_acl_options',
	'columns'	=> array('auth_option', 'is_local', 'is_global'),
	'data'		=> array(
		array('f_', 1, 0),
		array('f_announce', 1, 0),
		array('f_attach', 1, 0),
		array('f_bbcode', 1, 0),
		array('f_bump', 1, 0),
		array('f_delete', 1, 0),
		array('f_download', 1, 0),
		array('f_edit', 1, 0),
		array('f_email', 1, 0),
		array('f_flash', 1, 0),
		array('f_icons', 1, 0),
		array('f_ignoreflood', 1, 0),
		array('f_img', 1, 0),
		array('f_list', 1, 0),
		array('f_noapprove', 1, 0),
		array('f_poll', 1, 0),
		array('f_post', 1, 0),
		array('f_postcount', 1, 0),
		array('f_print', 1, 0),
		array('f_read', 1, 0),
		array('f_reply', 1, 0),
		array('f_report', 1, 0),
		array('f_search', 1, 0),
		array('f_sigs', 1, 0),
		array('f_smilies', 1, 0),
		array('f_sticky', 1, 0),
		array('f_subscribe', 1, 0),
		array('f_user_lock', 1, 0),
		array('f_vote', 1, 0),
		array('f_votechg', 1, 0),

		// Moderator related auth options
		array('m_', 1, 1),
		array('m_approve', 1, 1),
		array('m_chgposter', 1, 1),
		array('m_delete', 1, 1),
		array('m_edit', 1, 1),
		array('m_info', 1, 1),
		array('m_lock', 1, 1),
		array('m_merge', 1, 1),
		array('m_move', 1, 1),
		array('m_report', 1, 1),
		array('m_split', 1, 1),

		// Global moderator auth option (not a local option)
		array('m_ban', 0, 1),
		array('m_warn', 0, 1),

		// Admin related auth options
		array('a_', 0, 1),
		array('a_aauth', 0, 1),
		array('a_attach', 0, 1),
		array('a_authgroups', 0, 1),
		array('a_authusers', 0, 1),
		array('a_backup', 0, 1),
		array('a_ban', 0, 1),
		array('a_bbcode', 0, 1),
		array('a_board', 0, 1),
		array('a_bots', 0, 1),
		array('a_clearlogs', 0, 1),
		array('a_email', 0, 1),
		array('a_fauth', 0, 1),
		array('a_forum', 0, 1),
		array('a_forumadd', 0, 1),
		array('a_forumdel', 0, 1),
		array('a_group', 0, 1),
		array('a_groupadd', 0, 1),
		array('a_groupdel', 0, 1),
		array('a_icons', 0, 1),
		array('a_jabber', 0, 1),
		array('a_language', 0, 1),
		array('a_mauth', 0, 1),
		array('a_modules', 0, 1),
		array('a_names', 0, 1),
		array('a_phpinfo', 0, 1),
		array('a_profile', 0, 1),
		array('a_prune', 0, 1),
		array('a_ranks', 0, 1),
		array('a_reasons', 0, 1),
		array('a_roles', 0, 1),
		array('a_search', 0, 1),
		array('a_server', 0, 1),
		array('a_styles', 0, 1),
		array('a_switchperm', 0, 1),
		array('a_uauth', 0, 1),
		array('a_user', 0, 1),
		array('a_userdel', 0, 1),
		array('a_viewauth', 0, 1),
		array('a_viewlogs', 0, 1),
		array('a_words', 0, 1),

		// User related auth options
		array('u_', 0, 1),
		array('u_attach', 0, 1),
		array('u_chgavatar', 0, 1),
		array('u_chgcensors', 0, 1),
		array('u_chgemail', 0, 1),
		array('u_chggrp', 0, 1),
		array('u_chgname', 0, 1),
		array('u_chgpasswd', 0, 1),
		array('u_download', 0, 1),
		array('u_hideonline', 0, 1),
		array('u_ignoreflood', 0, 1),
		array('u_masspm', 0, 1),
		array('u_masspm_group', 0, 1),
		array('u_pm_attach', 0, 1),
		array('u_pm_bbcode', 0, 1),
		array('u_pm_delete', 0, 1),
		array('u_pm_download', 0, 1),
		array('u_pm_edit', 0, 1),
		array('u_pm_emailpm', 0, 1),
		array('u_pm_flash', 0, 1),
		array('u_pm_forward', 0, 1),
		array('u_pm_img', 0, 1),
		array('u_pm_printpm', 0, 1),
		array('u_pm_smilies', 0, 1),
		array('u_readpm', 0, 1),
		array('u_savedrafts', 0, 1),
		array('u_search', 0, 1),
		array('u_sendemail', 0, 1),
		array('u_sendim', 0, 1),
		array('u_sendpm', 0, 1),
		array('u_sig', 0, 1),
		array('u_viewonline', 0, 1),
		array('u_viewprofile', 0, 1),
	),
	'store_auto_increment'	=> 'AUTH_OPTION_ID',
);

// standard auth roles
$schema_data[] = array(
	'table'		=> 'phpbb_acl_roles',
	'columns'	=> array('role_name', 'role_description', 'role_type', 'role_order'),
	'data'		=> array(
		array('ROLE_ADMIN_STANDARD', 'ROLE_DESCRIPTION_ADMIN_STANDARD', 'a_', 1),
		array('ROLE_ADMIN_FORUM', 'ROLE_DESCRIPTION_ADMIN_FORUM', 'a_', 3),
		array('ROLE_ADMIN_USERGROUP', 'ROLE_DESCRIPTION_ADMIN_USERGROUP', 'a_', 4),
		array('ROLE_ADMIN_FULL', 'ROLE_DESCRIPTION_ADMIN_FULL', 'a_', 2),
		array('ROLE_USER_FULL', 'ROLE_DESCRIPTION_USER_FULL', 'u_', 3),
		array('ROLE_USER_STANDARD', 'ROLE_DESCRIPTION_USER_STANDARD', 'u_', 1),
		array('ROLE_USER_LIMITED', 'ROLE_DESCRIPTION_USER_LIMITED', 'u_', 2),
		array('ROLE_USER_NOPM', 'ROLE_DESCRIPTION_USER_NOPM', 'u_', 4),
		array('ROLE_USER_NOAVATAR', 'ROLE_DESCRIPTION_USER_NOAVATAR', 'u_', 5),
		array('ROLE_MOD_FULL', 'ROLE_DESCRIPTION_MOD_FULL', 'm_', 3),
		array('ROLE_MOD_STANDARD', 'ROLE_DESCRIPTION_MOD_STANDARD', 'm_', 1),
		array('ROLE_MOD_SIMPLE', 'ROLE_DESCRIPTION_MOD_SIMPLE', 'm_', 2),
		array('ROLE_MOD_QUEUE', 'ROLE_DESCRIPTION_MOD_QUEUE', 'm_', 4),
		array('ROLE_FORUM_FULL', 'ROLE_DESCRIPTION_FORUM_FULL', 'f_', 7),
		array('ROLE_FORUM_STANDARD', 'ROLE_DESCRIPTION_FORUM_STANDARD', 'f_', 5),
		array('ROLE_FORUM_NOACCESS', 'ROLE_DESCRIPTION_FORUM_NOACCESS', 'f_', 1),
		array('ROLE_FORUM_READONLY', 'ROLE_DESCRIPTION_FORUM_READONLY', 'f_', 2),
		array('ROLE_FORUM_LIMITED', 'ROLE_DESCRIPTION_FORUM_LIMITED', 'f_', 3),
		array('ROLE_FORUM_BOT', 'ROLE_DESCRIPTION_FORUM_BOT', 'f_', 9),
		array('ROLE_FORUM_ONQUEUE', 'ROLE_DESCRIPTION_FORUM_ONQUEUE', 'f_', 8),
		array('ROLE_FORUM_POLLS', 'ROLE_DESCRIPTION_FORUM_POLLS', 'f_', 6),
		array('ROLE_FORUM_LIMITED_POLLS', 'ROLE_DESCRIPTION_FORUM_LIMITED_POLLS', 'f_', 4),
		array('ROLE_USER_GUESTS', 'ROLE_DESCRIPTION_USER_GUESTS', 'u_', 6),
	),
	'store_auto_increment'	=> 'ROLE_ID',
);

// Permissions

$schema_data[] = array(
	'table'		=> 'phpbb_acl_groups',
	'columns'	=> array('group_id', 'forum_id', 'auth_option_id', 'auth_role_id', 'auth_setting'),
	'data'		=> array(
		// GUESTS - u_download and u_search ability
		array(array('auto_increment' => 'GROUP_ID:0'), 0, 0, array('auto_increment' => 'ROLE_ID:22'), 0),
		// ADMINISTRATOR Group - full user features
		array(array('auto_increment' => 'GROUP_ID:4'), 0, 0, array('auto_increment' => 'ROLE_ID:4'), 0),
		// ADMINISTRATOR Group - standard admin
		array(array('auto_increment' => 'GROUP_ID:4'), 0, 0, array('auto_increment' => 'ROLE_ID:0'), 0),
		// REGISTERED and REGISTERED_COPPA having standard user features
		array(array('auto_increment' => 'GROUP_ID:1'), 0, 0, array('auto_increment' => 'ROLE_ID:5'), 0),
		array(array('auto_increment' => 'GROUP_ID:2'), 0, 0, array('auto_increment' => 'ROLE_ID:5'), 0),
		// GLOBAL_MODERATORS having full user features
		array(array('auto_increment' => 'GROUP_ID:3'), 0, 0, array('auto_increment' => 'ROLE_ID:4'), 0),
		// GLOBAL_MODERATORS having full global moderator access
		array(array('auto_increment' => 'GROUP_ID:3'), 0, 0, array('auto_increment' => 'ROLE_ID:9'), 0),

		// Giving all groups read only access to the first category
		// since administrators and moderators are already within the registered users group we do not need to set them here
		array(array('auto_increment' => 'GROUP_ID:0'), array('auto_increment' => 'FORUM_ID:0'), 0, array('auto_increment' => 'ROLE_ID:16'), 0),
		array(array('auto_increment' => 'GROUP_ID:1'), array('auto_increment' => 'FORUM_ID:0'), 0, array('auto_increment' => 'ROLE_ID:16'), 0),
		array(array('auto_increment' => 'GROUP_ID:2'), array('auto_increment' => 'FORUM_ID:0'), 0, array('auto_increment' => 'ROLE_ID:16'), 0),
		array(array('auto_increment' => 'GROUP_ID:5'), array('auto_increment' => 'FORUM_ID:0'), 0, array('auto_increment' => 'ROLE_ID:16'), 0),

		// Giving access to the first forum
		// guests having read only access
		array(array('auto_increment' => 'GROUP_ID:0'), array('auto_increment' => 'FORUM_ID:1'), 0, array('auto_increment' => 'ROLE_ID:16'), 0),
		// registered and registered_coppa having standard access
		array(array('auto_increment' => 'GROUP_ID:1'), array('auto_increment' => 'FORUM_ID:1'), 0, array('auto_increment' => 'ROLE_ID:14'), 0),
		array(array('auto_increment' => 'GROUP_ID:2'), array('auto_increment' => 'FORUM_ID:1'), 0, array('auto_increment' => 'ROLE_ID:14'), 0),
		// global moderators having standard access + polls
		array(array('auto_increment' => 'GROUP_ID:3'), array('auto_increment' => 'FORUM_ID:1'), 0, array('auto_increment' => 'ROLE_ID:20'), 0),
		// administrators having full forum and full moderator access
		array(array('auto_increment' => 'GROUP_ID:4'), array('auto_increment' => 'FORUM_ID:1'), 0, array('auto_increment' => 'ROLE_ID:13'), 0),
		array(array('auto_increment' => 'GROUP_ID:4'), array('auto_increment' => 'FORUM_ID:1'), 0, array('auto_increment' => 'ROLE_ID:9'), 0),
		// Bots having bot access
		array(array('auto_increment' => 'GROUP_ID:5'), array('auto_increment' => 'FORUM_ID:1'), 0, array('auto_increment' => 'ROLE_ID:18'), 0),
	),
);

// phpbb_styles_imageset_data
$schema_data[] = array(
	'table'		=> 'phpbb_styles_imageset_data',
	'columns'	=> array('image_name', 'image_filename', 'image_lang', 'image_height', 'image_width', 'imageset_id'),
	'data'		=> array(
		array('site_logo', 'site_logo.gif', '', 52, 139, array('auto_increment' => 'IMAGESET_ID:0')),
		array('forum_link', 'forum_link.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('forum_read', 'forum_read.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('forum_read_locked', 'forum_read_locked.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('forum_read_subforum', 'forum_read_subforum.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('forum_unread', 'forum_unread.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('forum_unread_locked', 'forum_unread_locked.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('forum_unread_subforum', 'forum_unread_subforum.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('topic_moved', 'topic_moved.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('topic_read', 'topic_read.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('topic_read_mine', 'topic_read_mine.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('topic_read_hot', 'topic_read_hot.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('topic_read_hot_mine', 'topic_read_hot_mine.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('topic_read_locked', 'topic_read_locked.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('topic_read_locked_mine', 'topic_read_locked_mine.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('topic_unread', 'topic_unread.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('topic_unread_mine', 'topic_unread_mine.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('topic_unread_hot', 'topic_unread_hot.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('topic_unread_hot_mine', 'topic_unread_hot_mine.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('topic_unread_locked', 'topic_unread_locked.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('topic_unread_locked_mine', 'topic_unread_locked_mine.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('sticky_read', 'sticky_read.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('sticky_read_mine', 'sticky_read_mine.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('sticky_read_locked', 'sticky_read_locked.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('sticky_read_locked_mine', 'sticky_read_locked_mine.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('sticky_unread', 'sticky_unread.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('sticky_unread_mine', 'sticky_unread_mine.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('sticky_unread_locked', 'sticky_unread_locked.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('sticky_unread_locked_mine', 'sticky_unread_locked_mine.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('announce_read', 'announce_read.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('announce_read_mine', 'announce_read_mine.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('announce_read_locked', 'announce_read_locked.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('announce_read_locked_mine', 'announce_read_locked_mine.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('announce_unread', 'announce_unread.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('announce_unread_mine', 'announce_unread_mine.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('announce_unread_locked', 'announce_unread_locked.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('announce_unread_locked_mine', 'announce_unread_locked_mine.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('global_read', 'announce_read.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('global_read_mine', 'announce_read_mine.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('global_read_locked', 'announce_read_locked.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('global_read_locked_mine', 'announce_read_locked_mine.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('global_unread', 'announce_unread.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('global_unread_mine', 'announce_unread_mine.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('global_unread_locked', 'announce_unread_locked.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('global_unread_locked_mine', 'announce_unread_locked_mine.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('pm_read', 'topic_read.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('pm_unread', 'topic_unread.gif', '', 27, 27, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_back_top', 'icon_back_top.gif', '', 11, 11, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_contact_aim', 'icon_contact_aim.gif', '', 20, 20, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_contact_email', 'icon_contact_email.gif', '', 20, 20, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_contact_icq', 'icon_contact_icq.gif', '', 20, 20, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_contact_jabber', 'icon_contact_jabber.gif', '', 20, 20, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_contact_msnm', 'icon_contact_msnm.gif', '', 20, 20, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_contact_www', 'icon_contact_www.gif', '', 20, 20, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_contact_yahoo', 'icon_contact_yahoo.gif', '', 20, 20, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_post_delete', 'icon_post_delete.gif', '', 20, 20, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_post_info', 'icon_post_info.gif', '', 20, 20, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_post_report', 'icon_post_report.gif', '', 20, 20, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_post_target', 'icon_post_target.gif', '', 9, 11, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_post_target_unread', 'icon_post_target_unread.gif', '', 9, 11, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_topic_attach', 'icon_topic_attach.gif', '', 10, 7, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_topic_latest', 'icon_topic_latest.gif', '', 9, 11, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_topic_newest', 'icon_topic_newest.gif', '', 9, 11, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_topic_reported', 'icon_topic_reported.gif', '', 14, 16, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_topic_unapproved', 'icon_topic_unapproved.gif', '', 14, 16, array('auto_increment' => 'IMAGESET_ID:0')),
		array('icon_user_warn', 'icon_user_warn.gif', '', 20, 20, array('auto_increment' => 'IMAGESET_ID:0')),
		array('subforum_read', 'subforum_read.gif', '', 9, 11, array('auto_increment' => 'IMAGESET_ID:0')),
		array('subforum_unread', 'subforum_unread.gif', '', 9, 11, array('auto_increment' => 'IMAGESET_ID:0')),
	),
);

// Smilies
$schema_data[] = array(
	'table'		=> 'phpbb_smilies',
	'columns'	=> array('code', 'smiley_url', 'emotion', 'smiley_width', 'smiley_height', 'smiley_order'),
	'data'		=> array(
		array(':D', 'icon_e_biggrin.gif', '{L_SMILIES_VERY_HAPPY}', 15, 17, 1),
		array(':-D', 'icon_e_biggrin.gif', '{L_SMILIES_VERY_HAPPY}', 15, 17, 2),
		array(':grin:', 'icon_e_biggrin.gif', '{L_SMILIES_VERY_HAPPY}', 15, 17, 3),
		array(':)', 'icon_e_smile.gif', '{L_SMILIES_SMILE}', 15, 17, 4),
		array(':-)', 'icon_e_smile.gif', '{L_SMILIES_SMILE}', 15, 17, 5),
		array(':smile:', 'icon_e_smile.gif', '{L_SMILIES_SMILE}', 15, 17, 6),
		array(';)', 'icon_e_wink.gif', '{L_SMILIES_WINK}', 15, 17, 7),
		array(';-)', 'icon_e_wink.gif', '{L_SMILIES_WINK}', 15, 17, 8),
		array(':wink:', 'icon_e_wink.gif', '{L_SMILIES_WINK}', 15, 17, 9),
		array(':(', 'icon_e_sad.gif', '{L_SMILIES_SAD}', 15, 17, 10),
		array(':-(', 'icon_e_sad.gif', '{L_SMILIES_SAD}', 15, 17, 11),
		array(':sad:', 'icon_e_sad.gif', '{L_SMILIES_SAD}', 15, 17, 12),
		array(':o', 'icon_e_surprised.gif', '{L_SMILIES_SURPRISED}', 15, 17, 13),
		array(':-o', 'icon_e_surprised.gif', '{L_SMILIES_SURPRISED}', 15, 17, 14),
		array(':eek:', 'icon_e_surprised.gif', '{L_SMILIES_SURPRISED}', 15, 17, 15),
		array(':shock:', 'icon_eek.gif', '{L_SMILIES_SHOCKED}', 15, 17, 16),
		array(':?', 'icon_e_confused.gif', '{L_SMILIES_CONFUSED}', 15, 17, 17),
		array(':-?', 'icon_e_confused.gif', '{L_SMILIES_CONFUSED}', 15, 17, 18),
		array(':???:', 'icon_e_confused.gif', '{L_SMILIES_CONFUSED}', 15, 17, 19),
		array('8-)', 'icon_cool.gif', '{L_SMILIES_COOL}', 15, 17, 20),
		array(':cool:', 'icon_cool.gif', '{L_SMILIES_COOL}', 15, 17, 21),
		array(':lol:', 'icon_lol.gif', '{L_SMILIES_LAUGHING}', 15, 17, 22),
		array(':x', 'icon_mad.gif', '{L_SMILIES_MAD}', 15, 17, 23),
		array(':-x', 'icon_mad.gif', '{L_SMILIES_MAD}', 15, 17, 24),
		array(':mad:', 'icon_mad.gif', '{L_SMILIES_MAD}', 15, 17, 25),
		array(':P', 'icon_razz.gif', '{L_SMILIES_RAZZ}', 15, 17, 26),
		array(':-P', 'icon_razz.gif', '{L_SMILIES_RAZZ}', 15, 17, 27),
		array(':razz:', 'icon_razz.gif', '{L_SMILIES_RAZZ}', 15, 17, 28),
		array(':oops:', 'icon_redface.gif', '{L_SMILIES_EMARRASSED}', 15, 17, 29),
		array(':cry:', 'icon_cry.gif', '{L_SMILIES_CRYING}', 15, 17, 30),
		array(':evil:', 'icon_evil.gif', '{L_SMILIES_EVIL}', 15, 17, 31),
		array(':twisted:', 'icon_twisted.gif', '{L_SMILIES_TWISTED_EVIL}', 15, 17, 32),
		array(':roll:', 'icon_rolleyes.gif', '{L_SMILIES_ROLLING_EYES}', 15, 17, 33),
		array(':!:', 'icon_exclaim.gif', '{L_SMILIES_EXCLAMATION}', 15, 17, 34),
		array(':?:', 'icon_question.gif', '{L_SMILIES_QUESTION}', 15, 17, 35),
		array(':idea:', 'icon_idea.gif', '{L_SMILIES_IDEA}', 15, 17, 36),
		array(':arrow:', 'icon_arrow.gif', '{L_SMILIES_ARROW}', 15, 17, 37),
		array(':|', 'icon_neutral.gif', '{L_SMILIES_NEUTRAL}', 15, 17, 38),
		array(':-|', 'icon_neutral.gif', '{L_SMILIES_NEUTRAL}', 15, 17, 39),
		array(':mrgreen:', 'icon_mrgreen.gif', '{L_SMILIES_MR_GREEN}', 15, 17, 40),
		array(':geek:', 'icon_e_geek.gif', '{L_SMILIES_GEEK}', 17, 17, 41),
		array(':ugeek:', 'icon_e_ugeek.gif', '{L_SMILIES_UBER_GEEK}', 17, 18, 42),
	),
);

// icons
$schema_data[] = array(
	'table'		=> 'phpbb_icons',
	'columns'	=> array('icons_url', 'icons_width', 'icons_height', 'icons_order', 'display_on_posting'),
	'data'		=> array(
		array('misc/fire.gif', 16, 16, 1, 1),
		array('smile/redface.gif', 16, 16, 9, 1),
		array('smile/mrgreen.gif', 16, 16, 10, 1),
		array('misc/heart.gif', 16, 16, 4, 1),
		array('misc/star.gif', 16, 16, 2, 1),
		array('misc/radioactive.gif', 16, 16, 3, 1),
		array('misc/thinking.gif', 16, 16, 5, 1),
		array('smile/info.gif', 16, 16, 8, 1),
		array('smile/question.gif', 16, 16, 6, 1),
		array('smile/alert.gif', 16, 16, 7, 1),
	),
);

// reasons
$schema_data[] = array(
	'table'		=> 'phpbb_reports_reasons',
	'columns'	=> array('reason_title', 'reason_description', 'reason_order'),
	'data'		=> array(
		array('warez', '{L_REPORT_WAREZ}', 1),
		array('spam', '{L_REPORT_SPAM}', 2),
		array('off_topic', '{L_REPORT_OFF_TOPIC}', 3),
		array('other', '{L_REPORT_OTHER}', 4),
	),
);

// extension_groups
$schema_data[] = array(
	'table'		=> 'phpbb_extension_groups',
	'columns'	=> array('group_name', 'cat_id', 'allow_group', 'download_mode', 'upload_icon', 'max_filesize', 'allowed_forums'),
	'data'		=> array(
		array('{L_EXT_GROUP_IMAGES}', 1, 1, 1, '', 0, ''),
		array('{L_EXT_GROUP_ARCHIVES}', 0, 1, 1, '', 0, ''),
		array('{L_EXT_GROUP_PLAIN_TEXT}', 0, 0, 1, '', 0, ''),
		array('{L_EXT_GROUP_DOCUMENTS}', 0, 0, 1, '', 0, ''),
		array('{L_EXT_GROUP_REAL_MEDIA}', 3, 0, 1, '', 0, ''),
		array('{L_EXT_GROUP_WINDOWS_MEDIA}', 2, 0, 1, '', 0, ''),
		array('{L_EXT_GROUP_FLASH_FILES}', 5, 0, 1, '', 0, ''),
		array('{L_EXT_GROUP_QUICKTIME_MEDIA}', 6, 0, 1, '', 0, ''),
		array('{L_EXT_GROUP_DOWNLOADABLE_FILES}', 0, 0, 1, '', 0, ''),
	),
	'store_auto_increment'	=> 'EXT_GROUP_ID',
);

// extensions
$schema_data[] = array(
	'table'		=> 'phpbb_extensions',
	'columns'	=> array('group_id', 'extension'),
	'data'		=> array(
		array(array('auto_increment' => 'EXT_GROUP_ID:0'), 'gif'),
		array(array('auto_increment' => 'EXT_GROUP_ID:0'), 'png'),
		array(array('auto_increment' => 'EXT_GROUP_ID:0'), 'jpeg'),
		array(array('auto_increment' => 'EXT_GROUP_ID:0'), 'jpg'),
		array(array('auto_increment' => 'EXT_GROUP_ID:0'), 'tif'),
		array(array('auto_increment' => 'EXT_GROUP_ID:0'), 'tiff'),
		array(array('auto_increment' => 'EXT_GROUP_ID:0'), 'tga'),

		array(array('auto_increment' => 'EXT_GROUP_ID:1'), 'gtar'),
		array(array('auto_increment' => 'EXT_GROUP_ID:1'), 'gz'),
		array(array('auto_increment' => 'EXT_GROUP_ID:1'), 'tar'),
		array(array('auto_increment' => 'EXT_GROUP_ID:1'), 'zip'),
		array(array('auto_increment' => 'EXT_GROUP_ID:1'), 'rar'),
		array(array('auto_increment' => 'EXT_GROUP_ID:1'), 'ace'),
		array(array('auto_increment' => 'EXT_GROUP_ID:1'), 'torrent'),
		array(array('auto_increment' => 'EXT_GROUP_ID:1'), 'tgz'),
		array(array('auto_increment' => 'EXT_GROUP_ID:1'), 'bz2'),
		array(array('auto_increment' => 'EXT_GROUP_ID:1'), '7z'),

		array(array('auto_increment' => 'EXT_GROUP_ID:2'), 'txt'),
		array(array('auto_increment' => 'EXT_GROUP_ID:2'), 'c'),
		array(array('auto_increment' => 'EXT_GROUP_ID:2'), 'h'),
		array(array('auto_increment' => 'EXT_GROUP_ID:2'), 'cpp'),
		array(array('auto_increment' => 'EXT_GROUP_ID:2'), 'hpp'),
		array(array('auto_increment' => 'EXT_GROUP_ID:2'), 'diz'),
		array(array('auto_increment' => 'EXT_GROUP_ID:2'), 'csv'),
		array(array('auto_increment' => 'EXT_GROUP_ID:2'), 'ini'),
		array(array('auto_increment' => 'EXT_GROUP_ID:2'), 'log'),
		array(array('auto_increment' => 'EXT_GROUP_ID:2'), 'js'),
		array(array('auto_increment' => 'EXT_GROUP_ID:2'), 'xml'),

		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'xls'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'xlsx'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'xlsm'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'xlsb'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'doc'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'docx'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'docm'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'dot'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'dotx'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'dotm'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'pdf'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'ai'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'ps'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'ppt'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'pptx'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'pptm'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'odg'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'odp'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'ods'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'odt'),
		array(array('auto_increment' => 'EXT_GROUP_ID:3'), 'rtf'),

		array(array('auto_increment' => 'EXT_GROUP_ID:4'), 'rm'),
		array(array('auto_increment' => 'EXT_GROUP_ID:4'), 'ram'),

		array(array('auto_increment' => 'EXT_GROUP_ID:5'), 'wma'),
		array(array('auto_increment' => 'EXT_GROUP_ID:5'), 'wmv'),

		array(array('auto_increment' => 'EXT_GROUP_ID:6'), 'swf'),

		array(array('auto_increment' => 'EXT_GROUP_ID:7'), 'mov'),
		array(array('auto_increment' => 'EXT_GROUP_ID:7'), 'm4v'),
		array(array('auto_increment' => 'EXT_GROUP_ID:7'), 'm4a'),
		array(array('auto_increment' => 'EXT_GROUP_ID:7'), 'mp4'),
		array(array('auto_increment' => 'EXT_GROUP_ID:7'), '3gp'),
		array(array('auto_increment' => 'EXT_GROUP_ID:7'), '3g2'),
		array(array('auto_increment' => 'EXT_GROUP_ID:7'), 'qt'),

		array(array('auto_increment' => 'EXT_GROUP_ID:8'), 'mpeg'),
		array(array('auto_increment' => 'EXT_GROUP_ID:8'), 'mpg'),
		array(array('auto_increment' => 'EXT_GROUP_ID:8'), 'mp3'),
		array(array('auto_increment' => 'EXT_GROUP_ID:8'), 'ogg'),
		array(array('auto_increment' => 'EXT_GROUP_ID:8'), 'ogm'),
	),
);

?>